var appName = app.GetName();
var  appPath = "/sdcard/DroidScript/";
var tablet=false;
var orient = app.GetOrientation();
var layBack,layFront,laySamp,layDoc,scrollIcons,dlgShop;
var textSize=14, timer=0, lastLine=0;
var textChanged=false, lastProg="";
var tipCount=0, sharedApp=null;
var g_debugParams="", fix=1, dirty=false;
var isWebIDE=false; imgGrad = null;
var ignoreIcons=false, isSample = false;
var sharedFiles, sharedText, startedByShare;
var plgApk=null, playStore=null, purchases=[];
var pluginVersions=[], crypt=null;
var g_tester=false, hashCode="";
var tablet=false, lowRes=false, orient="Portrait";
var isHtml = false; var isSBC = false;
var useADB = false; var premium = true;
var net=null, port=19800, udpTimer=0;
var usePass = true, password="",deviceName="";
var curProgram = null, lstDlgCopy=null;
var useSoftKeys=true, stayAwake=true, lastCursorLine=0;
var headless=true,useAce=false,txtDebug=null,forceOrient="",noGUI=false;
var useDarkTheme=true, usingAce=false;
var lastCursorPos = [], curProgTitle=null;
var backcount = 0;

//Called when application is started.
function OnStart()
{
      theme = app.CreateTheme( "Light" );
        theme.AdjustColor( 35, 0, -10 );
        theme.SetBackColor( "#ffffffff" );
        theme.SetBtnTextColor( "#ffffffff" );
        theme.SetButtonOptions( "custom" );
        theme.SetButtonStyle( "#4285F4","#4285F4",2,"#999999",0,1,"#ff9000" );
        theme.SetCheckBoxOptions( "Light" );
		theme.SetTextEditOptions( "underline" );
        theme.SetDialogColor( "#ffffffff" );
        theme.SetDialogBtnColor( "#ffeeeeee" );
        theme.SetDialogBtnTxtColor( "#ff666666" );
        theme.SetTitleHeight( 42 );
        theme.SetTitleColor( "#ff888888" ); 
        theme.SetTitleDividerColor( "#ff0099CC" );
        theme.SetTextColor( "#ff666666" );
        app.SetTheme( theme );
app.EnableBackKey( false );
app.SetOrientation( "Portrait" );
	//Create a layout with objects vertically centered.
		lay = app.CreateLayout( "linear", "VCenter,FillXY" );	
	lay.SetBackground( "/res/drawable/pattern_carbon", "repeat" );

    //Create a full screen scroller.
    scroller = app.CreateScroller( 1.0, 1.0 );
    lay.AddChild( scroller );
    	
    //Display all activity icons.
    ShowIcons( scroller );
    
	//Add layout to app.	
	app.AddLayout( lay );
}
function ShowIcons()
{
	app.MakeFolder( appPath );
	
    layIcons = app.CreateLayout( "Linear", "FillXY,Left" );
    layIcons.SetPadding(0,0.02,0,0);
    
    //Get list of user's programs.
    var progList = GetProgramList().split(",");
    
    //Set icons per row count.
    var iconsPerRow = tablet ? 5 : 4;
    if( orient=="Landscape" ) { iconsPerRow = tablet ? 8 : 7; }
    var iconW = 0.76/(iconsPerRow);
     
    //Create an icon for each program.
    for( var i=0; i<progList.length && progList[0]!=""; i++ )
    {
        if( i%iconsPerRow==0 ) {
            layIconsHoriz = app.CreateLayout( "Linear", "Horizontal,FillXY" );
            layIcons.AddChild( layIconsHoriz );
        }
        //Create icon/text layout.
        var layIcon = app.CreateLayout( "Linear", "Vertical" );
        layIcon.SetMargins( 0.082/iconsPerRow, 0, 0.082/iconsPerRow, 0 );
        layIconsHoriz.AddChild( layIcon );
        
        //Get program icon.
        var file = appPath+"/"+progList[i]+"/Img/"+progList[i]+".png";
        if( !app.FileExists( file ) ) file = "/assets/Img/Icon.png";
        
        //Create icon image.
        var imgIcon = app.CreateImage( file, iconW, -1, "Square" ); 
        if( !imgIcon ) imgIcon = app.CreateImage( "/assets/Img/Icon.png", iconW, -1 ); 
       imgIcon.SetName( progList[i]);
        imgIcon.SetOnLongTouch(  lst_OnLongTouch );
        layIcon.AddChild( imgIcon );
        
        //Create text label.
        var txtIcon = app.CreateText( progList[i], iconW*1.1, -1, "Multiline" );
        txtIcon.SetTextSize( 1.0,0.5, "dip" );
        txtIcon.SetTextColor( "#ff666666" );
        layIcon.AddChild( txtIcon );
    }
    scroller.AddChild( layIcons );
    
    }

function RedrawIcons()
{
    scroller.DestroyChild( layIcons );
    DisplayIcons( scroller );
}

//Handle program long press.
function lst_OnLongTouch(imgIcon )
{
    var img = app.GetLastImage();
    img.SetAlpha( 1.0 );
    
    //Get program name.
    //item = item.split(":")[0];
    curProgram = imgIcon.source.GetName();

    //Show options dialog.
    var sOps = "Создать APK"; 
    lstOps = app.CreateListDialog( "Собрать", sOps,"ShowNow");
    lstOps.SetOnTouch( lstOps_Select ); 
}

function lstOps_Select( imgIcon )
{
 
    var privDir = app.GetPrivateFolder("Plugins");
        var plgFile = privDir+"/apkbuilder/ApkBuilder.jar";
        
           ShowAPKDialog();
}
function yesNoDelete_OnTouch( result )
{
    if( result=="Yes" ) {
        //Delete the file and refresh list.
        app.DeleteFolder( appPath+"/" + curProgram );
        //lst.SetList( GetProgramList(), "," );
        ShowIcons();
    }
}

//Called after user enters renamed pr
        function GetProgramList()
{
    var progList = "";
    var list = app.ListFolder( appPath,"",0,"alphasort");
    for( var i=0; i<list.length; i++ )
    {
        if( list[i].substr(0,1)!="~" )
        {
            if( app.FileExists( appPath+"/"+list[i]+"/"+list[i]+".js" ) ||
					app.FileExists( appPath+"/"+list[i]+"/"+list[i]+".html" ) ) 
			{
                if( progList.length>0 ) progList += ",";
                progList += list[i];
            }
        }
    }
    return progList;
}
function _LoadScriptX( url, callback )
{
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    
    if( url.indexOf("http:") >-1 ) {
        script.src = url;
        script.onload = callback;
    }
    else {
         //if (url.charAt[0] !== '/') 
         //   url = app.GetAppPath() + "/" + url;
        script.text = app.ReadFile( url );
        //script.defer = true;
        if( callback ) callback();
    }
    head.appendChild(script);
}

function _LoadPluginX( name )
{
    var privDir = app.GetPrivateFolder( "Plugins" );
    _LoadScriptX( privDir+"/"+name.toLowerCase()+"/"+name+".inc" );
}

function isValid(str){
 return !/[`!#$%\^&*+=\[\]\\';,/{}|\\":<>\?]/g.test(str);
}
function isValidFileName(str){
 return !/[`!#$%\^&*+=\[\]\\';,/{}|\\":<>\?]/g.test(str);
}
function OnMenu(){
var tt = app.GetCountry();
var ty = app.GetModel();
var tr = app.GetLanguage();
app.Alert( "Разработчик: MasterOS\nСайт: http://masteros.tk\nТелеграм: @dangerweb\nСтрана: " + tt + "\nМодел: " + ty, "О приложения");
}
function OnBack()
{
        timer = 1;
        counter = setInterval( Timer, 1000/1 );
        backcount++;
        if( backcount >= 2 )
        {
            app.Exit();
        }
        else
        {
            app.ShowPopup( "Нажмите ещё раз для выхода", "Bottom" );
        }
}
function Timer()
{
    {
        backcount = 0;
        return;
    }
    timer--; 
}
function ShowAPKDialog()
{
    //Create dialog window.
    dlgApk = app.CreateDialog( "Создать APK" );
     dlgApk.SetBackColor( "#ffffffff" );
    layApk = app.CreateLayout( "linear", "vertical" );
    layApk.SetSize( 0.9,0.6);
    layApk.SetPadding( 0.05, 0, 0.05, 0 );

    //Create 'package name' text box.
    var packTitle = curProgram.replace( RegExp( " ","gim"), "" ).toLowerCase();
    packTitle = packTitle.replace( RegExp( "-","gim"), "" );
    var packRoot = app.LoadText( "_userOrg", "com.myname", "spremote" );
    var packName = packRoot + "." + packTitle;
    packName = packName.replace("sw-","");
    packName = packName.replace("sws-","");
    txtApkPkg = app.CreateTextEdit( packName, 0.5 );
    layApk.AddChild( txtApkPkg );
    
    //Create 'version' text box.
    txtApkVer = app.CreateTextEdit( "1.00", 0.2 );
    layApk.AddChild( txtApkVer );
    
    //Create 'debug' checkbox.
    chkApkDbg = app.CreateCheckBox( "Отлад.  Сборка" );
    chkApkDbg.SetMargins( 0,8,0,8, "dip" );
    layApk.AddChild( chkApkDbg );
    chkApkDbg.SetChecked( true );
    chkApkDbg.SetOnTouch( chkApkDbg_OnTouch );
    
    //Create 'obfuscate code' checkbox.
    chkObfuscate = app.CreateCheckBox( "Обфускация кода" );
    chkObfuscate.SetMargins( 0,8,0,8, "dip" );
    layApk.AddChild( chkObfuscate );
    chkObfuscate.SetChecked( false );
    
    //Create 'include assets' checkbox.
    chkApkAssets = app.CreateCheckBox( "Вкл. Сист. Активы" );
    chkApkAssets.SetMargins( 0,0,0,8, "dip" );
    layApk.AddChild( chkApkAssets );
    chkApkAssets.SetChecked( true );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layApk2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layApk.AddChild( layApk2 );
    
    //Create OK button.
    layApk2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnApkOK = app.CreateButton( "OK", 0.3 );
    btnApkOK.SetOnTouch( btnApkOK_OnTouch );
    layApk2.AddChild( btnApkOK );
    
    //Create Cancel button.
    btnApkCancel = app.CreateButton( "Отмена", 0.3 );
    btnApkCancel.SetOnTouch( btnApkCancel_OnTouch );
    layApk2.AddChild( btnApkCancel );
   
    //Add dialog layout and show dialog.
    dlgApk.AddLayout( layApk );
    dlgApk.Show();
    
    //Set default password.
    keyPass = "Пароль";
}

//Handle debug check box.
function chkApkDbg_OnTouch( checked )
{
    if( !checked ) chkObfuscate.SetChecked( true );
}
        
function _LoadScriptX( url, callback )
{
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    
    if( url.indexOf("http:") >-1 ) {
        script.src = url;
        script.onload = callback;
    }
    else {
         //if (url.charAt[0] !== '/') 
         //   url = app.GetAppPath() + "/" + url;
        script.text = app.ReadFile( url );
        //script.defer = true;
        if( callback ) callback();
    }
    head.appendChild(script);
}

function _LoadPluginX( name )
{
    var privDir = app.GetPrivateFolder( "Plugins" );
    _LoadScriptX( privDir+"/"+name.toLowerCase()+"/"+name+".inc" );
}

function isValid(str){
 return !/[~`!#$%\^&*+=\-\[\]\\';,/{}|\\":<>\?]/g.test(str);
}

//Handle APK 'OK' click.
function btnApkOK_OnTouch()
{
	//Check package name is ok.
	var pkgName = txtApkPkg.GetText();
	var ret = pkgName.match( RegExp("(^|\\.)\\d","gim"), "" );
	if( ret ) { app.Alert( "В Названия пакета используйте только латинские буквы", "Ошибка" ); return; }
	if( !isValid(pkgName) || pkgName.indexOf(" ")>-1 ) { 
		app.Alert( "В Названия пакета используйте только латинские буквы", "Ошибка" ); return; }
	
	//Check version num is ok.
	var pkgVer = parseFloat(txtApkVer.GetText());
	if( isNaN( pkgVer ) ) { app.Alert( "Версия неправильно.Напиши вот так: 1.02", "Ошибка" ); return; }
	
    //Get debug mode and assets mode.
    debugApk = chkApkDbg.GetChecked();
    useApkAssets = chkApkAssets.GetChecked();
    obfuscate = chkObfuscate.GetChecked();
    
    //Check if we have a key store.
    keyFile = "/sdcard/DroidScript/APKs/user.keystore";
    keyFileDbg = "/sdcard/.DroidScript/debug.keystore";
    if( !debugApk && !app.FileExists( keyFile ) ) {
        ShowKeyStoreDialog();
        return;
    }
    
    //Build the APK.
    if( debugApk )  
        BuildAPK( txtApkPkg.GetText(), curProgram, 
            parseFloat(txtApkVer.GetText().replace(",",".")), obfuscate, "android" );
    else
       ShowPasswordDialog();

	//Save users organisation.
	var org = txtApkPkg.GetText();
	org = org.substr( 0, org.lastIndexOf(".") );
	app.SaveText( "_userOrg", org, "spremote" );
	
    //Remove dialog.
    dlgApk.Dismiss();
}

//Handle APK 'Cancel' click.
function btnApkCancel_OnTouch()
{
    //Remove dialog.
    dlgApk.Dismiss();
}

//Allow user to create key store.
function ShowKeyStoreDialog()
{
    //Create dialog window.
    dlgKey = app.CreateDialog( "Создать ключ" );
    dlgKey.SetBackColor( "#ffffffff" );
    layKey = app.CreateLayout( "linear", "vertical,fillxy" );
    layKey.SetPadding( 0.05, 0, 0.05, 0 );

    //Create info text.
    var info = "Вы должны создать личный ключ, чтобы подписать APK" +" архив. Пожалуйста, введите имя, организацию и пароль для " +"сгенерировать свой ключ.";
    txtKeyInfo = app.CreateText( info, 0.8, -1, "multiline" );
    txtKeyInfo.SetMargins( 0,0.04,0,0.04 );
    txtKeyInfo.SetTextSize( 16 );
    layKey.AddChild( txtKeyInfo );
     
    //Create 'Name' text box.
    txtKeyName = app.CreateTextEdit( "Персон", 0.6 );
    layKey.AddChild( txtKeyName );
    
    //Create 'Organization' text box.
    txtKeyOrg = app.CreateTextEdit( "Организация", 0.6 );
    layKey.AddChild( txtKeyOrg );
    
    //Create 'Password' text box.
    txtKeyPass = app.CreateTextEdit( keyPass, 0.6 );
    layKey.AddChild( txtKeyPass );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layKey2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layKey.AddChild( layKey2 );
    
    //Create OK button.
    layKey2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnKeyOK = app.CreateButton( "OK", 0.3);
    btnKeyOK.SetOnTouch( btnKeyOK_OnTouch );
    layKey2.AddChild( btnKeyOK );
    
    //Create Cancel button.
    btnKeyCancel = app.CreateButton( "Отмена", 0.3 );
    btnKeyCancel.SetOnTouch( btnKeyCancel_OnTouch );
    layKey2.AddChild( btnKeyCancel );
   
    //Add dialog layout and show dialog.
    dlgKey.AddLayout( layKey );
    dlgKey.Show();
}

//Handle Key dialog 'OK' click.
function btnKeyOK_OnTouch()
{
    //Get user key info.
    var name = txtKeyName.GetText();
    var org = txtKeyOrg.GetText();
    
    //Make sure APK's folder exists.
    var apkFldr = app.GetPath()+"/APKs";
    app.MakeFolder( apkFldr );
    
    //Create a user key store file and key.
    app.ShowProgress("Создания ключа...");
    zip = app.CreateZipUtil();
    zip.CreateKey( keyFile, txtKeyPass.GetText(), name, org );
    app.HideProgress();
    
    //Show warning.
    var warn = "A 'user.keystore' file has now been created in the " +
        "DroidScript/APKs folder.\n\nIt is STRONGLY recomended that you " +
        "backup this file. You cannot update Google Play Apps released using " +
        "this key, unless you have the original file (and can also " +
        "remember the password!)\n\n" + 
        "Note: If you rename or delete this file, you will be asked to " +
        "create a new one again.";
    app.Alert( warn, "WARNING" );
    
    //Save current password to memory.
    keyPass = txtKeyPass.GetText();
    
    //Save user org to settings.
    app.SaveText( "_userOrg", "com."+txtKeyOrg.GetText(), "spremote" );
    
    //Remove dialog.
    dlgKey.Dismiss();
    dlgKey.Release();
}

//Handle Key dialog 'Cancel' click.
function btnKeyCancel_OnTouch()
{
     //Remove dialog.
    dlgKey.Dismiss();
    dlgKey.Release();
}

//Show the APK password dialog.
function ShowPasswordDialog()
{
    //Create dialog window.
    dlgPass = app.CreateDialog( "Введите пароль ключа" );
    dlgPass.SetBackColor( "#ffffffff" );
    layPass = app.CreateLayout( "linear", "vertical,fillxy" );
    layPass.SetPadding( 0.05, 0.05, 0.05, 0 );

    //Create 'Password' text box.
    txtPass = app.CreateTextEdit( keyPass, 0.6 );
    layPass.AddChild( txtPass );
    
    //Create horizontal layout for Ok and Cancel buttons.
    layPass2 = app.CreateLayout( "linear", "horizontal,fillxy,center" );
    layPass.AddChild( layPass2 );
    
    //Create OK button.
    layPass2.SetMargins( 0, 0.02, 0, 0.01 );  
    btnPassOK = app.CreateButton( "OK", 0.3);
    btnPassOK.SetOnTouch( btnPassOK_OnTouch );
    layPass2.AddChild( btnPassOK );
    
    //Create Cancel button.
    btnPassCancel = app.CreateButton( "Отмена", 0.3);
    btnPassCancel.SetOnTouch( btnPassCancel_OnTouch );
    layPass2.AddChild( btnPassCancel );
   
    //Add dialog layout and show dialog.
    dlgPass.AddLayout( layPass );
    dlgPass.Show();
}

//Handle Pass dialog 'OK' click.
function btnPassOK_OnTouch()
{
    //Build the APK.
    BuildAPK( txtApkPkg.GetText(), curProgram, parseFloat(txtApkVer.GetText().replace(",",".")), 
                    obfuscate, txtPass.GetText() );
                    
    //Remove dialog.
    dlgPass.Dismiss();
    dlgPass.Release();
}

//Handle Pass dialog 'Cancel' click.
function btnPassCancel_OnTouch()
{
    //Remove dialog.
    dlgPass.Dismiss();
    dlgPass.Release();
}

function BuildAPK( packageName, appName, version, minify, pass )
{
    try
    {
        //Show progress dialog.
        app.ShowProgressBar( "Собрания APK...", 0, 0.5,"" );
         
        //Create APK plugin (if not created yet).
        if( !plgApk ) 
        {
            _LoadPluginX( "ApkBuilder" );
            plgApk = app.CreateObject( "ApkBuilder" );
            if( plgApk==null ) return; 
           
            var privDir = app.GetPrivateFolder( "Plugins" );
           _LoadScriptX( privDir+"/apkbuilder/Uglify/parse-js.js")
           _LoadScriptX( privDir+"/apkbuilder/Uglify/process.js")
           _LoadScriptX( privDir+"/apkbuilder/Uglify/consolidator.js")
           
           if( plgApk.GetVersion() < 1.6 ) alert( " Плагин APK Builder устарела!" );
        }
        
        //Copy base unsigned, unmanifested apk to temp folder.
        var apkFldr = app.GetPath()+"/APKs";
        var tmpFldr = "/sdcard/.DroidScript/Temp";
        var appFldr = app.GetPath()+"/"+appName;
        var privDir = app.GetPrivateFolder( "Plugins" );
        
        //Deal with smartwatch apps.
        options = "Launch";
        var isWatchApp = false;
        if( appName.indexOf("SWS-")>-1 ) { isWatchApp = true; options = ""; }
        var newName = appName.replace("SWS-", "");
        newName = newName.replace("SW-", "");
        
        //Create output apk file.
        var zipOut = app.CreateZipUtil();
        zipOut.Create( tmpFldr+"/"+newName+".apk" );
       
        //Open base apk file.
        var zipIn = app.CreateZipUtil();
        
        //Add appropriate engine.
        if( app.IsThings() ) 
			zipIn.Open( privDir+"/apkbuilder/engv8.dat" );
        else zipIn.Open( privDir+"/apkbuilder/eng.dat" );
        
        //Add new app icon.png file.
        var mainIcon = appFldr+"/Img/"+appName+".png";
        if( app.FileExists( mainIcon ) ) {
			zipOut.AddFile( "res/drawable/icon.png", mainIcon );
			zipOut.AddFile( "res/drawable-xhdpi/icon.png", mainIcon );
		}
		else {
			app.CopyFile( "/Sys/Img/Icon.png", tmpFldr+"/Icon.png" );
			zipOut.AddFile( "res/drawable/icon.png", tmpFldr+"/Icon.png" );
			zipOut.AddFile( "res/drawable-xhdpi/icon.png", tmpFldr+"/Icon.png" );
		}
			
        //Add watch icon (if present). 
        var watchIcon = appFldr+"/Img/"+appName+"-48x48.png"
        if( app.FileExists(watchIcon) ) 
            zipOut.AddFile( "res/drawable/icon_extension48.png", watchIcon );
         
        //Add user's files (and scan for permissions).
        permissions = ""; plugins = "";
        AddFolderWithScan( zipOut, "assets/user", appFldr, appName, minify, true );
         
        //Loop through adding rest of base apk contents.
        var lst = zipIn.List().split(",");
        for( var i=0; i<lst.length; i++ )
        {	
			//Get file extension and check for app.js file etc.
			var ext = lst[i].substr( lst[i].lastIndexOf(".") ).toLowerCase();
			var isMin = ( lst[i].toLowerCase().indexOf(".min.js") > -1 );
            var isJs = ( ext==".js" );
            var isHtml = ( ext==".html" || ext==".htm" );
            var isAppJs = ( lst[i].indexOf("assets/app.js")==0 );
            
			//Exclude '/Sys' assets if required.
			if( !useApkAssets ) {
				if( lst[i].indexOf("assets/Html/")==0 ) continue;
				else if( lst[i].indexOf("assets/Img/")==0 ) continue;
				else if( lst[i].indexOf("assets/Snd/")==0 ) continue;
			}
            //Extract file from source zip.
            zipIn.Extract( lst[i], tmpFldr+"/tmp.dat" );
            
            //Process js files.
			if( minify && isJs && !isMin ) {
				var code = app.ReadFile( tmpFldr+"/tmp.dat" );
				code = Swapify( code, isAppJs );
				app.WriteFile( tmpFldr+"/tmp.dat", code );
			}
			//Add to dest zip.
            zipOut.AddFile( lst[i], tmpFldr+"/tmp.dat" );
            
            //Update progress.
            app.UpdateProgressBar( i * 100/ lst.length );
        }
        
        //Loop through adding required plugins.
        var plugDir = app.GetPrivateFolder( "Plugins" );
        var plugNames = plugins.split(",");
        for( var i=0; plugins!="" && i<plugNames.length; i++ )
        {
			var name = plugNames[i];
			var nameLow = plugNames[i].toLowerCase();
			
			//Add each plugin file found at top level.
			var plugFiles = app.ListFolder( plugDir+"/"+nameLow,"");
			for( var p=0; p<plugFiles.length; p++ )
			{
				var plugFileName = plugFiles[p];
				var plugFilePath = plugDir+"/"+nameLow+"/"+plugFileName;

				if( app.IsFolder( plugFilePath ) ) continue;
			    if( plugFileName == name+'.html') continue;
			    
			    //Get file type.
			    var ext = plugFileName.substr( plugFileName.lastIndexOf(".") ).toLowerCase();
			    var isMin = ( plugFileName.toLowerCase().indexOf(".min.js") > -1 );
			    var isJs = ( ext==".js" );
			    var isInc = ( ext==".inc" );

				//Minify .inc and .js files.
				if( !isMin && (isInc || isJs) )
				{
					var code = app.ReadFile( plugFilePath );
					if( minify ) code = Swapify( code, false );
					zipOut.AddText( "assets/plugins/"+nameLow+"/"+plugFileName, code );
				}
				else zipOut.AddFile( "assets/plugins/"+nameLow+"/"+plugFileName, plugFilePath );
				  
				if( !isMin && (isInc || isJs) ) ScanFile( plugFilePath );
			}
        }
        
        //Add options file.
        zipOut.AddText( "assets/ops", options.toLowerCase() );
        
        //Add new manifest file using template.
        plgApk.UpdateManifest( privDir+"/apkbuilder/amf.dat", tmpFldr+"/tmp.dat", 
					packageName, newName, version, permissions, appFldr, options );
        zipOut.AddFile( "AndroidManifest.xml", tmpFldr+"/tmp.dat" );
        
        //Close zip files.
        zipIn.Close();
        zipOut.Close();
        
        //Create a debug key store if not done.
        if( !app.FileExists( keyFileDbg ) ) zipOut.CreateDebugKey( keyFileDbg );
    
        //Sign apk.
        app.MakeFolder( apkFldr );
        var apk =  apkFldr+"/"+newName+".apk";
        var ok = zipOut.Sign( tmpFldr+"/"+newName+".apk", apk, debugApk?keyFileDbg:keyFile, pass );
        if(!ok) { app.Alert( "Ключ или пароль неправильно!", "Ошибка" ); return; }
        
        //Remove unsigned version.
        app.DeleteFile( tmpFldr+"/"+newName+".apk" );
        
        //Tell user where APK is.
        var msg = "APK создан в папке:\n\n /DroidScript/APKs\n\nУстановить?"
    	var yesNoInst = app.CreateYesNoDialog( msg );
		yesNoInst.SetOnTouch( function(res){yesNoInst_OnTouch(res,apk)} );
		yesNoInst.Show();
    }
    finally {
        //Hide progess dialog.
        app.HideProgressBar();
    }
}

//APK complete/install dialog.
function yesNoInst_OnTouch( result, apkFile ) 
{
    if( result=="Yes" ) {
        if( app.FileExists( apkFile ) )  
            app.OpenFile( apkFile, "application/vnd.android.package-archive" );
    	else app.ShowPopup( "APK файл '" + apkFile + "' не найден!" );
    }
}
    
//Recursively add folder contents to zip.
function AddFolderWithScan( zip, name, fldr, appName, minify, isTop )
{
    var list = app.ListFolder( fldr,"");
    for( var i=0; i<list.length; i++ )
    {
        var title = list[i];
        if( !app.IsFolder( fldr+"/"+title ) )
        {
            //Scan .js and .html files for permissions.
            var ext = title.substr( title.lastIndexOf(".") ).toLowerCase();
            var isMin = ( title.toLowerCase().indexOf(".min.js") > -1 );
            var isJs = ( ext==".js" );
            var isHtml = ( ext==".html" || ext==".htm" );
            if( isTop && !isMin && (isJs || isHtml) ) ScanFile( fldr+"/"+title );
            
            //Swap spaces for underscores (for ICS bug)
            var newtitle = title;
            newtitle = newtitle.replace( RegExp( " ","gim"), "_" );
            
            //Add file to zip (with minify if required).
            if( isTop && minify && (isJs || isHtml) && !isMin ) 
            {
                var code = app.ReadFile( fldr+"/"+title );
				code = Swapify( code, false );
				if( !isHtml ) code = Uglify( title, code );
                zip.AddText( name+"/"+newtitle, code );
            }
            else zip.AddFile( name+"/"+newtitle, fldr+"/"+title );
        }
        else
            AddFolderWithScan( zip, name+"/"+title, fldr+"/"+title, appName, minify );
    }
}
   
//Scan a file for required Android permissions and plugins.
function ScanFile( file )
{
    var src = app.ReadFile( file );
    
    //Options.
    if( src.indexOf("app.GetShared") > -1 ) AddOption("Share");
    if( src.indexOf("app.GetIntent") > -1 ) AddOption("Share");
    if( src.indexOf("app.CreateUSBSerial") > -1 ) AddOption("USB");
    
    //Permissions.
    if( src.indexOf("app.CreateNetClient") > -1 ) AddPermission("Network");
    if( src.indexOf("XMLHttpRequest") > -1 ) AddPermission("Network");
    if( src.indexOf("app.GetIPAddress") > -1 ) AddPermission("Network");
    if( src.indexOf("app.GetMacAddress") > -1 ) AddPermission("Network");
    if( src.indexOf("app.GetSSID") > -1 ) AddPermission("Network");
    if( src.indexOf("app.CreateWebServer") > -1 ) AddPermission("Network");
    if( src.indexOf("new WebSocket") > -1 ) AddPermission("Network");
    if( src.indexOf("app.CreateEmail") > -1 ) AddPermission("Network");
    if( src.indexOf("\"http://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"https://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"rtsp://") > -1 ) AddPermission("Network");
    if( src.indexOf("\"ftp://") > -1 ) AddPermission("Network");
    if( src.indexOf("'http://") > -1 ) AddPermission("Network");
    if( src.indexOf("'https://") > -1 ) AddPermission("Network");
    if( src.indexOf("'rtsp://") > -1 ) AddPermission("Network");
    if( src.indexOf("'ftp://") > -1 ) AddPermission("Network");
    if( src.indexOf("GoProController") > -1 ) AddPermission("Network");
    if( src.indexOf("app.SetWifiEnabled") > -1 ) AddPermission("Network");
    if( src.indexOf("app.IsWifiEnabled") > -1 ) AddPermission("Network");
    if( src.indexOf("app.WifiConnect") > -1 ) AddPermission("Network");
    if( src.indexOf("app.SetOnWifiChange") > -1 ) AddPermission("Network");
    if( src.indexOf("app.IsConnected") > -1 ) AddPermission("Network");
    
    if( src.indexOf("app.CreateCameraView") > -1 ) AddPermission("Camera");
    
    if( src.indexOf("app.CreateLocator") > -1 ) AddPermission("Location");
    if( src.indexOf("app.CreateSMS") > -1 ) AddPermission("SMS");
    
    if( src.indexOf("app.PreventScreenLock") > -1 ) AddPermission("WakeLock");
    if( src.indexOf("app.PreventWifiSleep") > -1 ) AddPermission("WakeLock");
    if( src.indexOf("app.Unlock") > -1 ) AddPermission("Unlock");
    
    if( src.indexOf("app.CreateShortcut") > -1 ) AddPermission("Shortcut");
    if( src.indexOf("app.Vibrate") > -1 ) AddPermission("Vibrate");
    if( src.indexOf("app.CheckLicense") > -1 ) AddPermission("License");
    
    if( src.indexOf("app.CreateNxt") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.IsBluetoothOn") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.CreateBluetoothSerial") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.SetBluetoothEnabled") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("app.IsBluetoothEnabled") > -1 ) AddPermission("Bluetooth");
    if( src.indexOf("SpheroBall") > -1 ) AddPermission("Bluetooth");
    //if( src.indexOf("app.CreateIOIO( \"Bluetooth\" )") > -1 ) AddPermission("Bluetooth");
    if( src.match(/.*?app.CreateIOIO\(\s*?"Bluetooth"\s*?\).*?/i) ) AddPermission("Bluetooth");
    
    if( src.indexOf("app.FileExists") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.IsFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.FolderExists") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CreateFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.WriteFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.ReadFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CopyFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CopyFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.DeleteFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.OpenFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.DeleteFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.MakeFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.ListFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.RenameFile") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.RenameFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.GetExternalFolder") > -1 ) AddPermission("Storage");
    if( src.indexOf("\"file://") > -1 ) AddPermission("Storage");
    if( src.indexOf("'file://") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CreateAudioRecorder") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CreateMediaStore") > -1 ) AddPermission("Storage");
    if( src.indexOf(".TakePicture") > -1 ) AddPermission("Storage");
    if( src.indexOf("app.CreateEmail") > -1 ) AddPermission("Storage"); //Needed for attachments.
    
    if( src.indexOf("app.CreateContacts") > -1 ) AddPermission("Contacts");
    if( src.indexOf("content://com.android.contacts") > -1 ) AddPermission("Contacts");
    
    if( src.indexOf("app.CreateSmartWatch") > -1 ) AddPermission("SmartWatch2");
    if( src.indexOf("app.CreatePlayStore") > -1 ) AddPermission("Vending");
    
    if( src.indexOf("app.CreateAudioRecorder") > -1 ) AddPermission("Record");
    if( src.indexOf("app.CreateSpeechRec") > -1 ) AddPermission("Record");
    if( src.indexOf("app.CreateCameraView") > -1 && src.indexOf(".Record") > -1 ) AddPermission("Record");
    
    if( src.indexOf("app.SetRingerMode") > -1 ) AddPermission("Sounds");
    if( src.indexOf("app.SetVolume") > -1 ) AddPermission("Sounds");
    if( src.indexOf("app.SetSpeakerPhone") > -1 ) AddPermission("Sounds");
    if( src.indexOf("app.GetSpeakerPhone") > -1 ) AddPermission("Sounds");
    
    if( src.indexOf("app.Call") > -1 ) AddPermission("Phone");
    if( src.indexOf("app.CreatePhoneState") > -1 ) AddPermission("Phone");
    
    if( src.indexOf("app.GetUser") > -1 ) AddPermission("Accounts");
    if( src.indexOf("app.GetAccounts") > -1 ) AddPermission("Accounts");
    
    if( src.indexOf("app.SetAutoBoot") > -1 ) AddPermission("Boot");
    
    if( src.indexOf("HeartRate") > -1 ) AddPermission("Body");
    
    if( src.indexOf("content://com.android.calendar") > -1 ) AddPermission("Calendar");
    
    if( src.indexOf("app.SetKioskMode") > -1 ) AddPermission("SysWin");
    
    
    //Add extra user options.
    var re = /_AddOptions\( ?["|'](.*?)["|'] ?\)/g;
    while( match = re.exec(src) ) {
        var ops = match[1].split(",");
        for( i in ops ) AddOption( ops[i] );
    }
    
    //Add extra user permissions.
    var re = /_AddPermissions\( ?["|'](.*?)["|'] ?\)/g;
    while( match = re.exec(src) ) {
        var perms = match[1].split(",");
        for( i in perms ) AddPermission( perms[i] );
    }
    
    //Remove user permissions.
    var re = /_RemovePermissions\( ?["|'](.*?)["|'] ?\)/g;
    while( match = re.exec(src) ) {
        var perms = match[1].split(",");
        for( i in perms ) RemovePermission( perms[i] );
    }
    
    //Plugins.
    var re = /app.LoadPlugin\( ?["|'](.*?)["|'] ?\)/g;
    while( match = re.exec(src) ) AddPlugin( match[1] );
}

//Add a optinos (if not already added)
function AddOption( ops )
{
    if( options.indexOf( ops )==-1 ) {
        if( options ) options += ","; 
        options += ops; 
    }
}

//Add a permission (if not already added)
function AddPermission( perm )
{
    if( permissions.indexOf( perm )==-1 ) {
        if( permissions ) permissions += ","; 
        permissions += perm; 
    }
}

//Remove a permission.
function RemovePermission( perm ) {
    permissions = permissions.replace( perm, "" );
}

//Add a plugin to list (if not already added)
function AddPlugin( plugName )
{
    if( plugins.indexOf( plugName )==-1 ) {
        if( plugins ) plugins += ","; 
        plugins += plugName; 
    }
}

//Minify javascript code.
function require() {}
function Uglify( file, orig_code, options )
{
  options || (options = {});
    
  try {
      var ast = parse( orig_code );       // parse code and get the initial AST
      ast = ast_mangle( ast);            // get a new AST with mangled names
      ast = ast_squeeze( ast );          // get an AST with compression optimizations
      var final_code = gen_code( ast );  // compressed code here
      
      //alert( final_code );
      return final_code;
  }
  catch(e) { 
    alert( "Ошибка в обфускация " + file + ": " + e ); 
    return null; 
    }
};

//Swap method names for numbers.
function Swapify( str, isInclude )
{
    var meths =  Object.getOwnPropertyNames(app).filter(function(property) {
        return typeof app[property] == 'function';
    });
    
    result = str.replace(/app\.(.*?)\s*\(/g, function(m,p1) {
        var i = meths.indexOf(p1);
        return "app."+ (i>-1 ? "_"+i : p1) +"(";
    });
    
    if( isInclude )  {
         result = result.replace(/this\.(.*?) = f/g, function(m,p1) {
            var i = meths.indexOf(p1);
            return "this."+ (i>-1 ? "_"+i : p1) +" = f";
        });
    }
    return result;
}

//Convert a string to unicode escape sequences.
function ToUnicode( string )
{
    return string.replace(/[\s\S]/g, function (escape) {
       return '\\u' + ('0000' + escape.charCodeAt().toString(16)).slice(-4);
    });
}
function HandleReply( xmlHttp )
{
    try
    {
        if( xmlHttp.readyState==4 )
        {
            //If we got a valid response.
            if( xmlHttp.status==200 )
            {
                var info = JSON.parse(xmlHttp.responseText);
                //app.ShowPopup( "Response: " + info.version );
                var lastVersion = app.LoadNumber( "_LastNewsVersion", 0, "spremote" );
                if( info.version > lastVersion ) { 
                    ShowNews();
                    app.SaveNumber( "_LastNewsVersion", info.version, "spremote" );
                }
            }
        }
    }
    catch(e){}
}



//Rename AS folder to DS.
//(Called from app.js before extract)
function _CheckFolderName()
{
    if( app.FolderExists( "/sdcard/AndroidScript" ) )
    {
        if( !app.FolderExists( "/sdcard/DroidScript" ) )
           app.RenameFolder( "/sdcard/AndroidScript", "/sdcard/DroidScript" );
    }
}


function replaceAll(sString, sSearch, sReplace) 
{
    return sString.split(sSearch).join(sReplace);
}


//----- Coding menus -----------------------------------------------

var lastSearch="", lastReplace="", ccTimer=null;

function cc_UpdateList( type, list, onDot )
{
    //list.unshift( arrow );
    var lst = list.join("~");
    lst = lst.replace( "Destroy~","" );
    lst = lst.replace( "~Release","" );
    lst = lst.replace( "~IsGraphical","" );
    lst = lst.replace( "~_Extract","" );
    lst = lst.replace( "~Try","" );
    
    if( type=="Zip" ){
        lst = lst.replace( "~CreateKey","" );
        lst = lst.replace( "~CreateDebugKey","" );
        lst = lst.replace( "~Sign","" );
        lst = lst.replace( "~UpdateManifest","" );
    }
    lstCC.SetList( lst, "~" );
    
    if( onDot && layCC.GetVisibility()=="Hide" ) layCC.Animate( "SlideFromRight" );
}

function cc_ShowInfo( txt )
{
    infoTxt.SetText( txt );
}

function lstCC_OnTouch( item )
{
    try {
        if( item=="^q^" ) item = "\"";
        if( item.indexOf("&nbsp;") < 0 )
            cc.OnSelect( item );
    }
    catch( e ) {}
}


//Handle code comp info icon on info bar.
function infoBtn_OnTouchDown()
{
    if( layCopy.GetVisibility()=="Show" ) layCopy.Animate( "SlideToRight" );
    
    if( layCC.GetVisibility()=="Show" ) { 
        layCC.Animate( "SlideToRight" ); infoBtn.SetText("[fa-bars]"); 
    }
    else { layCC.Animate( "SlideFromRight" );  infoBtn.SetText("[fa-long-arrow-right]"); }
    
    if( laySrch.GetVisibility()=="Show" ) { 
        laySrch.Animate( "SlideToBottom" ); srchBtn.SetText("[fa-search]"); 
    }
}


//----- Code Completion -----------------------------------------------

//Code completion object.
function CodeComp( cbList, cbInfo )
{
    var m_curType="";
    var m_curObj="";
    var m_curMethod="", m_lastMethod="";
    var m_lastSuggest, m_lastFiltMethods = [];
    var m_types = { 
        App:"App", Layout:"Lay", Image:"Img", Button:"Btn", Toggle:"Tgl", 
        CheckBox:"Chk", Spinner:"Spn", SeekBar:"Skb", 
        ImageButton:"Ibn", Text:"Txt", TextEdit:"Txe", List:"Lst", WebView:"Web", 
        Scroller:"Scr", Dialog:"Dlg", YesNoDialog:"Ynd", ListView:"Lvw", 
        ListDialog:"Ldg", BluetoothList:"Btl", NetClient:"Net", MediaPlayer:"Aud", 
        Downloader:"Dwn", MediaStore:"Med", PlayStore:"Ply", AudioRecorder:"Rec", 
        Sensor:"Sns", Locator:"Loc", CameraView:"Cam", VideoView:"Vid", GLView:"GLV", 
        NxtRemote:"Nxt", BluetoothSerial:"Bts", ZipUtil:"Zip", Notification:"Not", 
        Crypt:"Crp", SpeechRec:"Spr", NxtInfo:"Inf", IOIO:"IOIO", SMS:"SMS", 
        Email:"EMAIL", WebServer:"Wbs", USBSerial:"Usb", SysProc:"Sys", Synth:"Syn" 
    };
    var m_useful = ["function","var","app","[tab]","=",",",";","(",")","{","}","\"","<",">","[","]"];
    var types = {Layout:"Lay", Image:"Img", Text:"Txt" };
    
    this.CheckSuggest = function()
    {
        var filtMethods = [];
        
        //Get all text and current cursor pos.
        var txt = edit.GetText();
        var curPos = edit.GetCursorPos();
    
        //Get dot and space positions.
        dotPos = txt.lastIndexOf(".",curPos);
        var spacePos = txt.lastIndexOf(" ",curPos-1);
        var newLinePos = txt.lastIndexOf("\n",curPos-1);
        var tabPos = txt.lastIndexOf("\t",curPos-1);
        spacePos = Math.max( spacePos, newLinePos );
        spacePos = Math.max( spacePos, tabPos );
        //app.ShowPopup( "dotPos=" + dotPos + " spacepos=" + spacePos );
        
        if( dotPos > spacePos )
        {
            //Get text after dot.
            var back = txt.substring(dotPos+1,curPos);
            var backLwr = back.toLowerCase();       
            var onDot = (dotPos==curPos-1);
            //app.ShowPopup( "[" + back + "]" );
            
            //Find object name.
            m_curObj = txt.substring( spacePos+1, dotPos );
            
            //Find Object's type.
            m_curType = GetObjType( m_curObj, txt ); 
            if( m_curObj=="app" ) m_curType = "App";
            //console.log( "curType = " + m_curType ); 
            
            if( m_curType )
            {
                //Find current method name.
                m_curMethod = "";
                var bracketPos = txt.indexOf("(",curPos);
                var endLinePos = txt.indexOf("\n",curPos);
                if( bracketPos > 1 && ( bracketPos < endLinePos || endLinePos<0) ) 
                {
                    m_curMethod = txt.substring(dotPos+1,bracketPos);
                    //console.log( "m_curMethod = " + m_curMethod ); 
                    if( m_curMethod != m_lastMethod ) {
                        ShowInfo( m_curType, m_curMethod );
                        m_lastMethod = m_curMethod;
                    }
                }
                
                //Get method list.
                var methods = GetFuncs(m_curType);
                if( methods )
                {
                    if( m_curMethod ) 
                        filtMethods = methods;
                    else {
                        //Get a filtered method list.
                        for( var key in methods ) {
                            if( methods[key].toLowerCase().indexOf(backLwr)>-1 ) 
                                filtMethods.push( methods[key] );
                        }
                    }
                }
            }
        }
        if( filtMethods.length==0 ) filtMethods = m_useful;
        if( filtMethods.toString() != m_lastFiltMethods ) 
        { 
            if( cbList ) cbList( m_curType, filtMethods.slice(0), onDot );
            m_lastFiltMethods = filtMethods.toString();
        }
    }
    
    this.OnSelect = function( funcName )
    {
        //var funcName = choice;
        var curPos = edit.GetCursorPos();
        var txt = edit.GetText();
        
        //Check for special macros.
        if( m_useful.indexOf(funcName)>-1 ) 
        {
            if( funcName=="function" ) { edit.InsertText( "function ()\n{\n\t\n}\n", curPos ); 
                    edit.SetCursorPos(curPos+9);  app.ShowKeyboard(edit); return; }
            else if( funcName=="{" ) { edit.InsertText( "{", curPos ); return; }
            else if( funcName=="}" ) { edit.InsertText( "}", curPos ); return; }
            else if( funcName==";" ) { edit.InsertText( ";", curPos ); return; }
            else if( funcName=="var" ) { edit.InsertText( "var ", curPos ); return; }
            else if( funcName=="=" ) { edit.InsertText( " = ", curPos ); return; }
            else if( funcName=="app" ) { edit.InsertText( "app.", curPos ); return; }
            else if( funcName=="[tab]" ) { edit.InsertText( "\t", curPos ); return; }
            else { edit.InsertText( funcName, curPos ); return; }
        }
        
        //Check for right hand bracket on same line.
        var bracketPos = txt.indexOf( "(", dotPos+1 );
        var spacePos = txt.indexOf(" ", dotPos+1 );
        var newLinePos = txt.indexOf("\n", dotPos+1 );
        
        //Count args of current method.
        var args = eval( "(new "+m_curType+"())."+funcName+".length" );
        //alert( args );
        
        //Get default params.
        var dflts = F_GetDefaults( m_curType+"."+funcName, args );
        
        //Add func to right side of dot (replace current func if bracket found).
        if( bracketPos > -1 && (spacePos==-1 || spacePos > bracketPos) && newLinePos > bracketPos ) 
            edit.ReplaceText( funcName+dflts[0], dotPos+1, bracketPos+2 );
        else 
            edit.ReplaceText( funcName+dflts[0], dotPos+1, curPos );
            
        //Move cursor past next bracket.
        //edit.SetCursorPos( dotPos + funcName.length + dflts[1] );
        var funcEnd = dotPos + funcName.length;
        edit.SetSelection( funcEnd + dflts[1], funcEnd + dflts[2] );
        
        //Show info for method.
        ShowInfo( m_curType, funcName );
    }
    
    //Show method info.
    function ShowInfo( objType, funcName )
    {
        if( m_curType ) {
            var func = eval("new "+objType+"()."+funcName );
            var params = GetParamNames( func );
            if( params ) cbInfo( funcName+"( "+params.join(", ")+" )" ); 
        }
    }
    
    //Find an objects type by scanning backwards
    //for the Create statement.
    function GetObjType( obj, txt )
    {
        try { var createPos = txt.search( new RegExp(obj+".*=.*Create(.*)\\(") ); }
        catch(e) {  return null; }
        if( createPos < 0 ) return null;
        //app.ShowPopup( createPos );
        var type = RegExp.$1.replace(" ","");
        //app.ShowPopup( obj+".*=.*Create(.*)\\(  -->" + "type=[" + type + "]" );
        
        //var types = {Layout:"Lay", Image:"Img", Text:"Txt" };
        //app.ShowPopup( "type=[" + types[type] + "]" );
        return m_types[type];
    }
    
    //Get all methods of an object.
    function GetFuncs( objName )
    {
        var obj = eval("new "+objName+"()" );
        
        //Get obj methods.
        var list = [];
        for (var Key in obj) {
          if (obj.hasOwnProperty(Key) && (typeof obj[Key] === 'function'))
          {
            list.push(Key);
          }
        }
        list.sort();
        return list;
    }
    
    //Get the names of a function's parameters.
    function GetParamNames( func ) 
    {
        if( func ) {
          //var STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/mg;
          var ARGUMENT_NAMES = /([^\s,]+)/g;
          var fnStr = func.toString();//.replace(STRIP_COMMENTS, '');
          var result = fnStr.slice(fnStr.indexOf('(')+1, fnStr.indexOf(')')).match(ARGUMENT_NAMES);
          if(result === null) result = [];
          return result;
        }
    }
    
    //Get default params for various funcs.
    function F_GetDefaults( method, numArgs )
    {
        if( numArgs==0 ) return ["();", 3,3];
        
        if( method=="App.Alert" ) return ["( \"\" );", 4,4];
        else if( method=="App.CreateLayout" ) return ["( \"Linear\", \"Horizontal\" );", 4,4];
        else if( method=="App.CreateText" ) return ["( \"\" );", 4,4];
        else if( method=="App.CreateButton" ) return ["( \"\" );", 4,4];
        else if( method=="App.CreateImage" ) return ["( \"Img/\", 0.5 );", 8,8];
        
        else if( method.indexOf(".SetTextColor") >-1 ) return ["( \"#22ff22\" );", 5,11];
        else if( method.indexOf(".SetBackColor") >-1 ) return ["( \"#cc22cc\" );", 5,11];
        else if( method.indexOf(".SetMargins") >-1 ) return ["( 0.01, 0.01, 0.01, 0.01 );", 5,5];
        else if( method.indexOf(".SetOnTouchUp") >-1 ) return ["( "+m_curObj+"_OnTouchUp );", 5,5];
        else if( method.indexOf(".SetOnTouchDown") >-1 ) return ["( "+m_curObj+"_OnTouchDown );", 5,5];
        else if( method.indexOf(".SetOnTouchMove") >-1 ) return ["( "+m_curObj+"_OnTouchMove );", 5,5];
        else if( method.indexOf(".SetOnTouch") >-1 ) return ["( "+m_curObj+"_OnTouch );", 5,5];
        
        
        else return ["(  );", 3,3];
    }
}